#include "const.h"

class LINK
{
   public:
	   int self_bs_idx;
	   int self_ms_idx;
	   int self_sector_idx;

	  // double combined_antgain;
	   complex <double> TransmitterAntennaGainXLOS_theta;
	   complex <double> TransmitterAntennaGainXLOS_pi;
	   complex <double> ReceiverAntennaGainXLOS_theta;
	   complex <double> ReceiverAntennaGainXLOS_pi;
	   complex <double> ReceiverAntennaGainXLOS_theta_panel_2;
	   complex <double> ReceiverAntennaGainXLOS_pi_panel_2;

	   complex <double> MAX_ReceiverAntennaGainXLOS_theta;
	   complex <double> MAX_ReceiverAntennaGainXLOS_pi;


	   MatrixXcd SmallScale_TX_AntennaGainXLOS_theta;
	   MatrixXcd SmallScale_TX_AntennaGainXLOS_pi;
	   MatrixXcd SmallScale_RX_AntennaGainXLOS_theta;
	   MatrixXcd SmallScale_RX_AntennaGainXLOS_pi;
	   MatrixXcd SmallScale_RX_AntennaGainXLOS_theta_panel_2;
	   MatrixXcd SmallScale_RX_AntennaGainXLOS_pi_panel_2;

	   MatrixXcd MAX_SmallScale_RX_AntennaGainXLOS_theta;
	   MatrixXcd MAX_SmallScale_RX_AntennaGainXLOS_pi;


	   //double RSRP_antgain;

	   double link_distance;
	   double link_pathloss;
	   double link_coupling_loss;
	   double link_prev_MAX_RSRP;
	   double link_prev_Random_RSRP;
	   double link_prev_UE_MAX_RSRP;
	   double link_antgain;
	   double link_array_factor[12];
	   double link_RMS_delay_spread;
	   double link_AOA_spread;
	   double link_AOD_spread;
	   double distance;
	   double signal;
	   double interference;
	   double SINR;
	   double str_signal;
	   LOCATION serving_bs;

	   //UE_Initial_Setting
	   double incar_loss;
	   double Otoi_loss;
	   //double UE_ICI;
	   //double UE_PATH_LOSS;
	   double * tone_sinr;
	   double     _throughput;
	   double CQI_offset;
	   int num_added;
	   int num_re_tx;
	   bool ACK;
	   //double strongest_signal;

	   //Find adjacent sector
	   double  *  LS_gain;
	   double  *  static_gain;
	   int     *  adj_sector;
	   int    _sector_in_control;

	   void Configuration(int);
	   void Delete_link_memory();
	   void Get_signal_interference();
	   void Get_adj_SECTORS();
	   void Get_interference();
	   double Get_angle(LOCATION, LOCATION, LOCATION);
	   double Get_antgain(LOCATION, LOCATION, int, int, int, int);

	   double Get_MS_antgain(int, int, int, int, int, int, int, int );

	   void Get_TX_SmallScale_antgain(LOCATION, int, int, int, int);
	   void Get_RX_SmallScale_antgain(int, int, int, int, int, int, int, int);
	   double Get_RSRP(int, int, int, int, int, int);
	   void UE_Initial_Setting(void);

	   int selected_a;
	   int selected_z;
	   int selected_p;

	   int azimuth_angle_idx_selected;
	   int zenith_angle_idx_selected;
	   int panel_idx_selected;

	   int azimuth_angle_idx_selected_for_interference;  // selected angle
	   int zenith_angle_idx_selected_for_interference;
	   int panel_idx_selected_for_interference;
	   
	   int sector_a;
	   int sector_z;

	   int sector_azimuth_angle_idx;
	   int sector_zenith_angle_idx;


};