#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

#include "const.h"
#include "common.h"
#include "Logging_Point.h"

/*===================================================================
FUNCTION: Throughput_CDF()


===================================================================*/
/*
void Throughput_CDF(void)
{
	if (drop_idx == 0)
	{
		throuhput_ue = new double[num_drop*num_MS];
	}
	
	for (int i = 0; i < num_MS; i++)
	{
		throuhput_ue[drop_idx*num_MS + i] = ms[i].Return_Throughput(i)* 1000. / run_times * pow(10., -7.) * (11. / 14.);
	}
	
	if (drop_idx == (num_drop - 1))
	{
		STASTICS Throughput_stastics;
		Throughput_stastics.setup(throuhput_ue, num_drop*num_MS, (char*)"Throughput");
		Throughput_stastics.get_cdf();
		Throughput_stastics.print_cdf();
	}
	
}
*/

/*===================================================================
FUNCTION: Averaging_Sinr()


===================================================================*/
void Averaging_Sinr(int ue_idx, double sinr)
{
	if (avr_sinr == NULL)
	{
		

		avr_sinr = new double[num_drop*num_MS];
		for (int ue_idx = 0; ue_idx < num_drop*num_MS; ue_idx++)
		{
			avr_sinr[ue_idx] = 0;
		}

		num_of_added = new int[num_drop*num_MS];
		for (int ue_idx = 0; ue_idx < num_drop*num_MS; ue_idx++)
		{
			num_of_added[ue_idx] = 0;
		}

		//cout << "avr sinr NULL??" << endl;
		//getchar();
	}

	//cout << "avr sinr NULL2" << endl;
	//getchar();

	if (!isinf(sinr)) // sinr not infinite
	{
		//cout << "avr sinr NULL3" << endl;
		avr_sinr[drop_idx*num_MS + ue_idx] += sinr;
		num_of_added[drop_idx*num_MS + ue_idx]++;

		//cout << "avr_sinr[drop_idx*num_MS + ue_idx] = " << avr_sinr[drop_idx*num_MS + ue_idx] << endl;
		//cout << "ue_idx = " << ue_idx << endl;
		//getchar();


	}
}

/*===================================================================
FUNCTION: Coupling_Loss_Get()


===================================================================*/
void Coupling_Loss_Get(double cp_ue, int ue_idx)
{
	if (drop_idx == 0 && ue_idx == 0)
	{
		coupling_loss = new double[num_drop*num_MS];
	}

	coupling_loss[ue_idx + drop_idx * num_MS] = cp_ue;
	//cout  << coupling_loss[ue_idx + drop_idx * num_MS] << endl;
	
}


/*===================================================================
FUNCTION: Coupling_Loss_CDF()


===================================================================*/
void Coupling_Loss_CDF(void)
{
	STASTICS cp_stastics;
	if (scenario == 11)  ///////InH
	{
		if (num_Indoor_TRxP == 1)
		{
			if (Configuration_Type == 0)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_A_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_A_Model_B");
				}
			}
			else if (Configuration_Type == 1)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_B_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_B_Model_B");
				}

			}
			else if (Configuration_Type == 2)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_C_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_config_C_Model_B");
				}

			}
		}
		else if (num_Indoor_TRxP == 3)
		{
			if (Configuration_Type == 0)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_A_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_A_Model_B");
				}
			}
			else if (Configuration_Type == 1)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_B_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_B_Model_B");
				}

			}
			else if (Configuration_Type == 2)
			{
				if (Channel_Model_Type == 0)
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_C_Model_A");
				}
				else
				{
					cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_InH_36TRxP_config_C_Model_B");
				}

			}
		}
		else
		{
			cout << " = num_Indoor_TRxP = ERROR! --> Coupling_Loss_CDF " << endl;
			getchar();
		}



	}
	else if (scenario == 12)  ///////// DenseUrban
	{
		if (Configuration_Type == 0)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_A_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_A_Model_B");
			}
		}
		else if (Configuration_Type == 1)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_B_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_B_Model_B");
			}

		}
		else if (Configuration_Type == 2)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_C_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_DenseUrban_config_C_Model_B");
			}

		}
	}
	else if (scenario == 13)   ////// Rural
	{
		if (Configuration_Type == 0)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_A_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_A_Model_B");
			}
		}
		else if (Configuration_Type == 1)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_B_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_B_Model_B");
			}

		}
		else if (Configuration_Type == 2)
		{
			if (Channel_Model_Type == 0)
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_C_Model_A");
			}
			else
			{
				cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"DL_CP_loss_Rural_config_C_Model_B");
			}

		}
	}



	////////////////////////cp_stastics.setup(coupling_loss, num_drop*num_MS, (char*)"Coupling_loss_DL");
	cp_stastics.get_cdf();
	cp_stastics.print_cdf();
}


/*===================================================================
FUNCTION: Geometry_CDF()



===================================================================*/
void Get_Geometry(double geometry_ue, int ue_idx)
{
	if (drop_idx == 0 && ue_idx == 0)
	{
		geometry = new double[num_drop*num_MS];
	}

	geometry[ue_idx + drop_idx * num_MS] = geometry_ue;
	//cout << "get geometry[" << ue_idx + drop_idx * num_MS <<  "] = " <<  geometry[ue_idx + drop_idx * num_MS] << endl;
}

/*===================================================================
FUNCTION: Geometry_CDF()



===================================================================*/
void Geometry_CDF(void)
{
	STASTICS geo_stastics;
	
	//geo_stastics.setup(geometry, num_drop*num_MS, (char*)"Geometry_DL");

	if (TYPE == 11)  ///////InH
	{

		if (num_Indoor_TRxP == 1)
		{
			if (Configuration_Type == 0)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_A_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_A_Model_B");
				}
			}
			else if (Configuration_Type == 1)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_B_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_B_Model_B");
				}

			}
			else if (Configuration_Type == 2)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_C_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_config_C_Model_B");
				}

			}
		}
		else if (num_Indoor_TRxP == 3)
		{
			if (Configuration_Type == 0)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_A_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_A_Model_B");
				}
			}
			else if (Configuration_Type == 1)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_B_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_B_Model_B");
				}

			}
			else if (Configuration_Type == 2)
			{
				if (Channel_Model_Type == 0)
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_C_Model_A");
				}
				else
				{
					geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_InH_36TRxP_config_C_Model_B");
				}

			}
		}
		else
		{
			cout << " = num_Indoor_TRxP = ERROR! --> Coupling_Loss_CDF " << endl;
			getchar();
		}


		
	}
	else if (TYPE == 12)  ///////// DenseUrban
	{
		if (Configuration_Type == 0)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_A_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_A_Model_B");
			}
		}
		else if (Configuration_Type == 1)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_B_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_B_Model_B");
			}

		}
		else if (Configuration_Type == 2)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_C_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_DenseUrban_config_C_Model_B");
			}

		}
	}
	else if (TYPE == 13)   ////// Rural
	{
		if (Configuration_Type == 0)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_A_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_A_Model_B");
			}
		}
		else if (Configuration_Type == 1)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_B_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_B_Model_B");
			}

		}
		else if (Configuration_Type == 2)
		{
			if (Channel_Model_Type == 0)
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_C_Model_A");
			}
			else
			{
				geo_stastics.setup(geometry, num_drop*num_MS, (char*)"DL_Geometry_Rural_config_C_Model_B");
			}

		}
	}

	geo_stastics.get_cdf();
	geo_stastics.print_cdf();
	
}


/*===================================================================
FUNCTION: Geometry_CDF()



===================================================================*/
void Get_RMS_delay_spread(double RMS_delay_spread_ue, int ue_idx)
{
	if (drop_idx == 0 && ue_idx == 0)
	{
		RMS_delay_spread = new double[num_drop*num_MS];
	}

	RMS_delay_spread[ue_idx + drop_idx * num_MS] = RMS_delay_spread_ue;
	//cout << "get geometry[" << ue_idx + drop_idx * num_MS <<  "] = " <<  geometry[ue_idx + drop_idx * num_MS] << endl;
}

/*===================================================================
FUNCTION: Geometry_CDF()



===================================================================*/
void RMS_delay_spread_CDF(void)
{
	STASTICS RMS_stastics;

	RMS_stastics.setup(RMS_delay_spread, num_drop*num_MS, (char*)"RMS_delay_spread_DL");
	RMS_stastics.get_cdf();
	RMS_stastics.print_cdf();

}



/*===================================================================
FUNCTION: Geometry_CDF()


===================================================================*/
void Get_circular_angle_spread_AOA(double angle_spread_AOA_ue, int ue_idx)
{
	if (drop_idx == 0 && ue_idx == 0)
	{
		circular_angle_spread_AOA = new double[num_drop*num_MS];
	}

	circular_angle_spread_AOA[ue_idx + drop_idx * num_MS] = angle_spread_AOA_ue;
	//cout << "get geometry[" << ue_idx + drop_idx * num_MS <<  "] = " <<  geometry[ue_idx + drop_idx * num_MS] << endl;
}


void circular_angle_spread_AOA_CDF(void)
{
	STASTICS AOA_stastics;

	AOA_stastics.setup(circular_angle_spread_AOA, num_drop*num_MS, (char*)"angle_spread_AOA_DL");
	AOA_stastics.get_cdf();
	AOA_stastics.print_cdf();

}

void Get_circular_angle_spread_AOD(double angle_spread_AOD_ue, int ue_idx)
{
	if (drop_idx == 0 && ue_idx == 0)
	{
		circular_angle_spread_AOD = new double[num_drop*num_MS];
	}

	circular_angle_spread_AOD[ue_idx + drop_idx * num_MS] = angle_spread_AOD_ue;
	//cout << "get geometry[" << ue_idx + drop_idx * num_MS <<  "] = " <<  geometry[ue_idx + drop_idx * num_MS] << endl;
}

void circular_angle_spread_AOD_CDF(void)
{
	STASTICS AOD_stastics;

	AOD_stastics.setup(circular_angle_spread_AOD, num_drop*num_MS, (char*)"angle_spread_AOD_DL");
	AOD_stastics.get_cdf();
	AOD_stastics.print_cdf();

}


/*===================================================================
FUNCTION: Plos()



===================================================================*/
void Plos(void)
{
	int los_count = 0;
	for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
	{
		/*
		if (los[ue_idx][ms[ue_idx]._sector_in_control] == 1)
		{
			los_count++;
		}
		*/
	}
}

/*===================================================================
FUNCTION: SINR_CDF()


===================================================================*/
void SINR_CDF(void)
{



	for (int ue_idx = 0; ue_idx < num_drop*num_MS; ue_idx++)
	{

		avr_sinr[ue_idx] = linear2dB(avr_sinr[ue_idx] / num_of_added[ue_idx]);
	}

	STASTICS sinr_stastics;
	sinr_stastics.setup(avr_sinr, num_drop*num_MS, (char*)"SINR_DL");
	sinr_stastics.get_cdf();
	sinr_stastics.print_cdf();

}








