#include <iostream>
#include <fstream>

using namespace std;

#include <cstring>
#include <cstdlib>

#include "common.h"
#include "const.h"
/*===================================================================
FUNCTION: PerDropStatistics( void )

AUTHOR: SJ

DESCRIPTION: Per-Drop Statistics are output

NOTES:

===================================================================*/
double Total_Avr;
double Total_Min;
double SF_avr;


void PerDropStatistics(int drop_idx)
{

	//// For calibration test
	/*
	ofstream TESToutputfile("TEST_output_file_MS.dat");
	TESToutputfile << "--------------------------- Simulation Configure ---------------------------" << endl;
	TESToutputfile << " MS_index " << '\t' << "MS_StaticGain_dB" << '\t' << "MS_interference_dB" << '\t' << "MS_Geometry_dB" << '\t' << "MS_throughput" << '\t' << "MS_sum_of_ch_coef_mean" << '\t' << "MS_BLER_mean" << '\t' << "MS_decision_BLER_mean" << endl;
	TESToutputfile << "----------------------------------------------------------------------------" << endl;
	TESToutputfile << "--------------------------- drop_idx = " << drop_idx + 1 << " --------------------------------- " << endl;

	for (int ms_idx = 0; ms_idx < num_MS; ms_idx++)
	{
		double linear_signal = dBm2linear(link[ms_idx].str_signal);
		double linear_interference = dBm2linear(link[ms_idx].interference);

		linear_interference = linear_interference + noise;

		double sum_of_ch_coef = 0.;

		for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
		{
			
			for (int r_idx = 0; r_idx < NUM_RX; r_idx++) // Received    Channel
			{
				for (int t_idx = 0; t_idx < NUM_TX; t_idx++) // Transmitted Channel
				{
					sum_of_ch_coef += pow(abs(ms[ms_idx].H_m[rb_idx](r_idx, t_idx)), 2.);
				}
			}
		}

		TESToutputfile << ms_idx << '\t' << link[ms_idx].str_signal << '\t' << link[ms_idx].interference << '\t' << linear2dB(linear_signal / linear_interference) << '\t' << ms[ms_idx].Return_Throughput(ms_idx) * 1000. / run_times * pow(10., -7.) << '\t' << sum_of_ch_coef / num_rbs_in_1ms << '\t' << ms[ms_idx].BLER_SUM_Value / (double)ms[ms_idx].BLER_SUM_count << '\t' << ms[ms_idx].decision_BLER_SUM_Value / (double)ms[ms_idx].decision_BLER_SUM_count << endl;
	}
	TESToutputfile.close();
	*/


	if (drop_idx == 0)
	{
		Total_Avr = 0.;
		Total_Min = 0.;
		SF_avr = 0.;
	}


	// For Calibration
	/*
	ofstream TESToutputSECTOR("TEST_output_file_SECTOR.dat");
	TESToutputSECTOR << "--------------------------- Simulation Configure ---------------------------" << endl;
	TESToutputSECTOR << " Sector_index " << '\t' << "link_MS_Size" << '\t' << "link_MS_index" << '\t' << "Sector_throughput" << endl;
	TESToutputSECTOR << "----------------------------------------------------------------------------" << endl;
	TESToutputSECTOR << "--------------------------- drop_idx = " << drop_idx + 1 << " --------------------------------- " << endl;
	*/

	double *per_sector_thru = new double[num_SECTORS]; 
	//double per_sector_thru[num_SECTORS];

	for (int sector_idx = 0; sector_idx < num_SECTORS; sector_idx++)
	{
		per_sector_thru[sector_idx] = 0;
		for (int ue_idx = 0; ue_idx < (int)sector[sector_idx].ue_in_control.size(); ue_idx++)
		{
			int ue2consider = sector[sector_idx].ue_in_control[ue_idx];
			per_sector_thru[sector_idx] += ms[ue2consider].Return_Throughput(ue2consider); 
			//TESToutputSECTOR << sector_idx << '\t' << (int)sector[sector_idx].ue_in_control.size() << '\t' << ue2consider << '\t' << per_sector_thru[sector_idx] * 1000. / run_times * pow(10., -7.) << endl;
		}
	}

	//TESToutputSECTOR.close();

	
	double avg_thru = 0;
	double min_thru = per_sector_thru[0];
	double max_thru = per_sector_thru[0];

	
	for (int sector_idx = 0; sector_idx < num_SECTORS; sector_idx++)
	{
		avg_thru += per_sector_thru[sector_idx];

		if (min_thru > per_sector_thru[sector_idx]) 
		{ 
			min_thru = per_sector_thru[sector_idx]; 
		}

		if (max_thru < per_sector_thru[sector_idx]) 
		{ 
			max_thru = per_sector_thru[sector_idx]; 
		}

	}
	
	
	ofstream  OutputFile;

	
	if (drop_idx == 0)
	{
		OutputFile.open(file_name, ios::out);
		OutputFile << "--------------------------- Simulation Configure ---------------------------" << endl;
		OutputFile << " num_drops        = " << num_drop << endl;
		OutputFile << " run_times        = " << run_times << endl;
		OutputFile << " num_user_cell    = " << num_MS_persector << endl;
		OutputFile << " scenario         = " << TYPE << endl;
		OutputFile << " Schedule Type    = " << Scheduling_Type << endl;
		OutputFile << "----------------------------------------------------------------------------" << endl;

	}
	else { OutputFile.open(file_name, ios::app); }

	OutputFile << "--------------------------- drop_idx = " << drop_idx + 1 << " --------------------------------- " << endl;
	

		OutputFile << "Sector Thruput [Avg, Max, Min] (b/s/Hz) = ";
		OutputFile << "[ " << avg_thru / num_SECTORS * 1000. / run_times * pow(10., -7.)
			<< ", " << max_thru  * 1000. / run_times * pow(10., -7.)
			<< ", " << min_thru  *1000. / run_times * pow(10., -7.)
			<< "]" << endl;


		
		
		

	
	Total_Avr += avg_thru / num_SECTORS * 1000. / run_times * pow(10., -7.);

	//compute ue thru 

	long double *per_ue_thru = new long double[num_MS];
	long double *ue_statistics = new long double[num_MS]; 

	//long double per_ue_thru[num_MS];   //
	//long double ue_statistics[num_MS]; //

	int cell_edge_ue_idx = (int)(num_MS * 0.05); // cell edge user

	for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
	{
		per_ue_thru[ue_idx] = ms[ue_idx].Return_Throughput(ue_idx);
		ue_statistics[ue_idx] = per_ue_thru[ue_idx];
	}

	long double tmp;
	bool swap;
	do
	{
		swap = false; //sorting frequence in order of cqi
		for (int ue_idx = 0; ue_idx < num_MS - 1; ue_idx++)
		{
			if (ue_statistics[ue_idx] > ue_statistics[ue_idx + 1])
			{
				tmp = ue_statistics[ue_idx];
				ue_statistics[ue_idx] = ue_statistics[ue_idx + 1];
				ue_statistics[ue_idx + 1] = tmp;
				swap = true;
			}
		}
	} while (swap);

	long double avg_ue_thru = 0;
	long double min_ue_thru = ue_statistics[cell_edge_ue_idx];
	long double max_ue_thru = ue_statistics[num_MS - 1];

	for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
	{
		avg_ue_thru += ue_statistics[ue_idx];
	}



	double avg_initial_pe = 0;
	for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
	{
		avg_initial_pe += ms[ue_idx].Return_initial_packet_error() / num_MS;
	}


	/////////////////////// Average Capacity /////////////////

	double capacity_avr_drop = 0;
	for (int idx = 0; idx < (run_times - 1); idx++)
	{
		//capacity_avr_drop += Capacity_avr_per_drop[drop_idx][idx];
		capacity_avr_drop += 0.;
	}


	//////////////////////////////////////////////////////////


		OutputFile << "    UE Thruput [Avg, Max, Min] (b/s/Hz) = ";
		OutputFile << "[ " << avg_ue_thru / num_MS * 1000. / run_times * pow(10., -7.)
			<< ", " << max_ue_thru * 1000. / run_times * pow(10., -7.)
			<< ", " << min_ue_thru * 1000. / run_times * pow(10., -7.)
			<< "]" << endl;

	


	OutputFile << " Initial Packet Erro = " << avg_initial_pe << endl;
	
	//OutputFile << " Average Spectral Efficiency (from MIMO capacity) = " << (capacity_avr_drop / (run_times - 1)) / bandwidth << "bits/s/Hz" << endl;
	//OutputFile << " Shannon Capacity (from MIMO capacity) = " << (capacity_avr_drop / (run_times - 1)) / (pow(10, 6)) << "Mbits/s" << endl;

	OutputFile << "--------------------------------------------------------------------------" << endl;

	Total_Min += min_ue_thru * 1000. / run_times * pow(10., -7.);

	SF_avr += (capacity_avr_drop / (run_times - 1)) / bandwidth;

	if (drop_idx == num_drop - 1)
	{
		OutputFile << " Sector  AVR = " << Total_Avr / num_drop << endl;
		OutputFile << " Minimum AVR = " << Total_Min / num_drop << endl;
		//OutputFile << " Spectral Efficiency AVR (from MIMO capacity) = " << SF_avr / num_drop << endl;
		OutputFile.close();
	}

	

}


